Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkClipVolume Class Reference

`#include <vtkClipVolume.h>`

Inheritance diagram for vtkClipVolume:

[legend]
Collaboration diagram for vtkClipVolume:

[legend]
List of all members.

## Detailed Description

clip volume data with user-specified implicit function or input scalar data

Date:
  2002/11/03 22:51:55

Revision:
  1.35

vtkClipVolume is a filter that clips volume data (i.e., structured points) using either: any subclass of vtkImplicitFunction; or the input scalar data. Clipping means that it actually "cuts" through the cells of the dataset, returning everything inside of the specified implicit function (or greater than the scalar value) including "pieces" of a cell. (Compare this with vtkExtractGeometry or vtkGeometryFilter, which pulls out entire, uncut cells.) The output of this filter is a 3D unstructured grid (e.g., tetrahedra).

To use this filter, you must decide if you will be clipping with an implicit function, or whether you will be using the input scalar data. If you want to clip with an implicit function, you must first define and then set the implicit function with the SetClipFunction() method. Otherwise, you must make sure input scalar data is available. You can also specify a scalar value, which is used to decide what is inside and outside of the implicit function. You can also reverse the sense of what inside/outside is by setting the InsideOut instance variable. (The cutting algorithm proceeds by computing an implicit function value or using the input scalar data for each point in the dataset. This is compared to the scalar value to determine inside/outside.)

This filter can be configured to compute a second output. The second output is the portion of the volume that is clipped away. Set the GenerateClippedData boolean on if you wish to access this output data.

Warning:
  This filter is designed to function with 3D structured points. Clipping 2D images can be better done by converting the image to polygonal data and using vtkClipPolyData,

See also:
  vtkImplicitFunction vtkClipPolyData vtkGeometryFilter vtkExtractGeometry

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (60%)
  - Geveci, Berk (10%)
  - Law, Charles (9%)
  - Miller, Jim (5%)
  - Lorensen, Bill (5%)

CVS logs (CVSweb):
  - .`cxx` (`/Graphics/vtkClipVolume.cxx)`
  - .`h` (`/Graphics/vtkClipVolume.h)`

Tests:
  vtkClipVolume (Tests)

Definition at line 89 of file vtkClipVolume.h.

## Public Types
typedef vtkStructuredPointsToUnstructuredGridFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
vtkUnstructuredGrid * | GetClippedOutput ()
void | CreateDefaultLocator ()
unsigned long int | GetMTime ()
virtual void | SetValue (float)
virtual float | GetValue ()
virtual void | SetInsideOut (int)
virtual int | GetInsideOut ()
virtual void | InsideOutOn ()
virtual void | InsideOutOff ()
virtual void | SetClipFunction (vtkImplicitFunction *)
virtual vtkImplicitFunction * | GetClipFunction ()
virtual void | SetGenerateClipScalars (int)
virtual int | GetGenerateClipScalars ()
virtual void | GenerateClipScalarsOn ()
virtual void | GenerateClipScalarsOff ()
virtual void | SetGenerateClippedOutput (int)
virtual int | GetGenerateClippedOutput ()
virtual void | GenerateClippedOutputOn ()
virtual void | GenerateClippedOutputOff ()
virtual void | SetMergeTolerance (float)
virtual float | GetMergeTolerance ()
void | SetLocator (vtkPointLocator *locator)
virtual vtkPointLocator * | GetLocator ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkClipVolume * | SafeDownCast (vtkObject *o)
vtkClipVolume * | New ()
## Protected Methods
| vtkClipVolume (vtkImplicitFunction *cf=NULL)
| ~vtkClipVolume ()
void | Execute ()
void | ClipVoxel (float value, vtkDataArray *cellScalars, int flip, float origin[3], float spacing[3], vtkIdList *cellIds, vtkPoints *cellPts, vtkPointData *inPD, vtkPointData *outPD, vtkCellData *inCD, vtkIdType cellId, vtkCellData *outCD, vtkCellData *clippedCD)
## Protected Attributes
vtkImplicitFunction * | ClipFunction
vtkPointLocator * | Locator
int | InsideOut
float | Value
int | GenerateClipScalars
float | MergeTolerance
int | GenerateClippedOutput
vtkUnstructuredGrid * | ClippedOutput

## Member Typedef Documentation

typedef vtkStructuredPointsToUnstructuredGridFilter vtkClipVolume::Superclass

| Reimplemented from vtkStructuredPointsToUnstructuredGridFilter. Definition at line 92 of file vtkClipVolume.h.

## Constructor & Destructor Documentation

vtkClipVolume::vtkClipVolume | ( | vtkImplicitFunction * | cf = NULL | ) | `[protected]`

vtkClipVolume::~vtkClipVolume | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkClipVolume::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkStructuredPointsToUnstructuredGridFilter.

int vtkClipVolume::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkStructuredPointsToUnstructuredGridFilter.

virtual int vtkClipVolume::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkStructuredPointsToUnstructuredGridFilter.

vtkClipVolume* vtkClipVolume::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkStructuredPointsToUnstructuredGridFilter.

void vtkClipVolume::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkStructuredPointsToUnstructuredGridFilter.

vtkClipVolume* vtkClipVolume::New | ( |  | ) | `[static]`

| Construct with user-specified implicit function; InsideOut turned off; value set to 0.0; and generate clip scalars turned off. The merge tolerance is set to 0.01. Reimplemented from vtkObject.

virtual void vtkClipVolume::SetValue | ( | float |  | ) | `[virtual]`

| Set the clipping value of the implicit function (if clipping with implicit function) or scalar value (if clipping with scalars). The default value is 0.0.

virtual float vtkClipVolume::GetValue | ( |  | ) | `[virtual]`

| Set the clipping value of the implicit function (if clipping with implicit function) or scalar value (if clipping with scalars). The default value is 0.0.

virtual void vtkClipVolume::SetInsideOut | ( | int |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual int vtkClipVolume::GetInsideOut | ( |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual void vtkClipVolume::InsideOutOn | ( |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual void vtkClipVolume::InsideOutOff | ( |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual void vtkClipVolume::SetClipFunction | ( | vtkImplicitFunction * |  | ) | `[virtual]`

| Specify the implicit function with which to perform the clipping. If you do not define an implicit function, then the input scalar data will be used for clipping.

virtual vtkImplicitFunction* vtkClipVolume::GetClipFunction | ( |  | ) | `[virtual]`

| Specify the implicit function with which to perform the clipping. If you do not define an implicit function, then the input scalar data will be used for clipping.

virtual void vtkClipVolume::SetGenerateClipScalars | ( | int |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual int vtkClipVolume::GetGenerateClipScalars | ( |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual void vtkClipVolume::GenerateClipScalarsOn | ( |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual void vtkClipVolume::GenerateClipScalarsOff | ( |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual void vtkClipVolume::SetGenerateClippedOutput | ( | int |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the unstructured grid that's been clipped away.

virtual int vtkClipVolume::GetGenerateClippedOutput | ( |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the unstructured grid that's been clipped away.

virtual void vtkClipVolume::GenerateClippedOutputOn | ( |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the unstructured grid that's been clipped away.

virtual void vtkClipVolume::GenerateClippedOutputOff | ( |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the unstructured grid that's been clipped away.

vtkUnstructuredGrid* vtkClipVolume::GetClippedOutput | ( |  | ) |

| Return the clipped output.

virtual void vtkClipVolume::SetMergeTolerance | ( | float |  | ) | `[virtual]`

| Set the tolerance for merging clip intersection points that are near the corners of voxels. This tolerance is used to prevent the generation of degenerate tetrahedra.

virtual float vtkClipVolume::GetMergeTolerance | ( |  | ) | `[virtual]`

| Set the tolerance for merging clip intersection points that are near the corners of voxels. This tolerance is used to prevent the generation of degenerate tetrahedra.

void vtkClipVolume::SetLocator | ( | vtkPointLocator * | locator | ) |

| Set / Get a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

virtual vtkPointLocator* vtkClipVolume::GetLocator | ( |  | ) | `[virtual]`

| Set / Get a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

void vtkClipVolume::CreateDefaultLocator | ( |  | ) |

| Create default locator. Used to create one when none is specified. The locator is used to merge coincident points.

unsigned long int vtkClipVolume::GetMTime | ( |  | ) | `[virtual]`

| Return the mtime also considering the locator and clip function. Reimplemented from vtkObject.

void vtkClipVolume::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

void vtkClipVolume::ClipVoxel | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | int | flip,
|  | float | origin[3],
|  | float | spacing[3],
|  | vtkIdList * | cellIds,
|  | vtkPoints * | cellPts,
|  | vtkPointData * | inPD,
|  | vtkPointData * | outPD,
|  | vtkCellData * | inCD,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCD,
|  | vtkCellData * | clippedCD
| ) | `[protected]`

## Member Data Documentation

vtkImplicitFunction* vtkClipVolume::ClipFunction`[protected]`

| Definition at line 180 of file vtkClipVolume.h.

vtkPointLocator* vtkClipVolume::Locator`[protected]`

| Definition at line 181 of file vtkClipVolume.h.

int vtkClipVolume::InsideOut`[protected]`

| Definition at line 182 of file vtkClipVolume.h.

float vtkClipVolume::Value`[protected]`

| Definition at line 183 of file vtkClipVolume.h.

int vtkClipVolume::GenerateClipScalars`[protected]`

| Definition at line 184 of file vtkClipVolume.h.

float vtkClipVolume::MergeTolerance`[protected]`

| Definition at line 185 of file vtkClipVolume.h.

int vtkClipVolume::GenerateClippedOutput`[protected]`

| Definition at line 187 of file vtkClipVolume.h.

vtkUnstructuredGrid* vtkClipVolume::ClippedOutput`[protected]`

| Definition at line 188 of file vtkClipVolume.h.

The documentation for this class was generated from the following file:

- Graphics/vtkClipVolume.h